// Header file for classes for ezrpm -- By Warren E. Downs
// August 26, 1999

// Purpose: These classes handle directories, packages, capabilities, and files.

class Tfile {
public:
	char			*name;
	Tfile			*next;
	
	Tfile(char *name);
	Tfile			*add(Tfile *file);
	~Tfile();
	};

class Tcapability {
public:
	char			*name;
	Tcapability		*next;
	
	Tcapability(char *name);
	Tcapability		*add(Tcapability *cap);
	~Tcapability();
	};
	
class Tdir;

class Tpackage {
public:
	Tdir			*path;
	char			*name;
	Tpackage		*next;
	Tcapability		*caps;
	Tfile			*files;
	
	Tpackage(Tdir *path, char *name);
	Tpackage		*add(Tpackage *pkg);
	Tcapability		*add(Tcapability *cap);
	Tfile			*add(Tfile *file);
	~Tpackage();
	};
	
class Tdir {
public:
	char			*name;
	char			*prompt;
	Tdir			*next;
	Tpackage		*pkgs;
	
	Tdir(char *name, char *prompt);
	Tdir 	 		*add(Tdir *next);
	Tpackage		*add(Tpackage *pkg);
	~Tdir();
	};

class Trpm {
private:
public:
	char 			*name;
	Trpm			*next;
	
	Trpm(char *name);
	Trpm 	 		*add(Trpm *next);
	char			*getName();
	~Trpm();
	};
	